<template>
  <div id="chart" align="center">
    <ResultPanel
      v-if="breeds"
      :top-breed="topBreed()"
      :top-value="topValue()">
    </ResultPanel>
    <apexchart
      type="bar"
      height="380"
      width="70%"
      :options="chartOptions"
      :series="series">
    </apexchart>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts';
import ResultPanel from '@/components/ResultPanel';
import breedMapping from '@/config/breedMapping.json';
import ru from 'apexcharts/dist/locales/ru.json';

export default {
  name: 'prediction',
  components: {
    apexchart: VueApexCharts,
    ResultPanel,
  },
  props: {
    breeds: Array,
    predictionValues: Array,
  },
  methods: {
    topBreed() {
      return breedMapping[this.breeds[0]];
    },
    topValue() {
      return Math.floor(this.predictionValues[0] * 100);
    },
  },
  data() {
    const predictionValues = this.predictionValues;
    return {
      series: [{
        data: this.predictionValues.map(val => Math.floor(val * 100)),
      }],
      chartOptions: {
        chart: {
          type: 'bar',
          height: 380,
          locales: [ru],
          defaultLocale: 'ru',
        },
        plotOptions: {
          bar: {
            barHeight: '100%',
            distributed: true,
            horizontal: true,
            dataLabels: {
              position: 'bottom',
            },
          },
        },
        colors: ['#33b2df', '#934392', '#d4526e', '#13d8aa', '#A5978B'],
        dataLabels: {
          enabled: true,
          textAnchor: 'start',
          style: {
            colors: ['#ffffff'],
          },
          formatter(val, opt) {
            return `${opt.w.globals.labels[opt.dataPointIndex]}:  ${val}%`;
          },
          offsetX: 0,
          dropShadow: {
            enabled: true,
          },
        },
        stroke: {
          width: 1,
          colors: ['#fcfcfc'],
        },
        xaxis: {
          max: 100,
          categories: this.breeds.map(breed => breedMapping[breed]),
        },
        yaxis: {
          labels: {
            show: false,
          },
        },
        title: {
          text: 'Результат классификации',
          align: 'center',
          floating: true,
          style: {
            fontFamily: 'Andale Mono, monospace',
            fontSize: '13pt',
          },
        },
        subtitle: {
          text: '',
          align: 'center',
        },
        tooltip: {
          followCursor: true,
          theme: 'dark',
          x: {
            show: true,
          },
          y: {
            formatter(val, opt) {
              return `${predictionValues[opt.dataPointIndex]}`;
            },
            title: {
              formatter() {
                return 'Вероятность';
              },
            },
          },
        },
      },
    };
  },
};
</script>

<style scoped>

</style>
